
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP实现发红包程序 / 憋错料</title>

    <meta name="description" content="PHP实现发红包程序 我们先来分析下规律. 设定总金额为10元,有N个人随机领取: N=1 第一个 则红包金额=X元: N=2 第二个 为保证第二个红包可以正常发出,第一个红包金额=0.01至9.99之间的某个随机数. 第二个红包=10-第一个红包金额: N=3 第三个 红包1=0.01至9.99之间的某个随机数 红包2=0.01至(10-红包1-0.01)的某个随机数 红包3=10-红包1-红包2 -- 于是我们得到一个规律,在分配当前红包金额时,先预留剩余红白所需最少金额,然后在0.01至总金额-预留金额间取随机">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">PHP实现发红包程序</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>我们先来分析下规律。</p>
<p>设定总金额为10元，有N个人随机领取：</p>
<p>N=1 第一个</p>
<p>则红包金额=X元；</p>
<p>N=2 第二个</p>
<p>为保证第二个红包可以正常发出，第一个红包金额=0.01至9.99之间的某个随机数。</p>
<p>第二个红包=10-第一个红包金额；</p>
<p>N=3 第三个</p>
<p>红包1=0.01至9.99之间的某个随机数</p>
<p>红包2=0.01至(10-红包1-0.01)的某个随机数</p>
<p>红包3=10-红包1-红包2</p>
<p>……</p>
<p>于是我们得到一个规律，在分配当前红包金额时，先预留剩余红白所需最少金额，然后在0.01至总金额-预留金额间取随机数，得到的随机数就是当前红包分配的金额。</p>
<p>实际应用中，程序先将红包金额分配好，即发红包时，红包个数以及每个红包的金额都分配好了，那么用户来抢红包时，我们随机给用户返回一个红包即可。</p>
<pre>$total=20;//红包总金额
$num=10;// 分成10个红包，支持10人随机领取
$min=0.01;//每个人最少能收到0.01元   

for ($i=1;$i&lt;$num;$i++)
{
    $safe_total=($total-($num-$i)*$min)/($num-$i);//随机安全上限
    $money=mt_rand($min*100,$safe_total*100)/100;
    $total=$total-$money;  

    echo ‘第‘.$i.‘个红包：‘.$money.‘ 元，余额：‘.$total.‘ 元 ‘;
}
echo ‘第‘.$num.‘个红包：‘.$total.‘ 元，余额：0 元‘;   </pre>
<p>运行以上代码，会输出以下结果：</p>
<p>第1个红包，金额2.08元，余额17.92元</p>
<p>第2个红包，金额1.81元，余额16.11元</p>
<p>第3个红包，金额0.15元，余额15.96元</p>
<p>第4个红包，金额1.61元，余额14.35元</p>
<p>第5个红包，金额1.11元，余额13.24元</p>
<p>第6个红包，金额1.51元，余额11.73元</p>
<p>第7个红包，金额1.21元，余额10.52元</p>
<p>第8个红包，金额2.58元，余额7.94元</p>
<p>第9个红包，金额5.4元，余额2.54元</p>
<p>第10个红包，金额2.54元，余额0元</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 18:34:40 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/pre/" title="pre">pre</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>, <a href="https://www.biecuoliao.com/tag/%e6%94%af%e6%8c%81/" title="支持">支持</a>, <a href="https://www.biecuoliao.com/tag/10%e4%b8%aa/" title="10个">10个</a>, <a href="https://www.biecuoliao.com/tag/ota/" title="ota">ota</a>, <a href="https://www.biecuoliao.com/tag/1-2/" title="1&period;2">1&period;2</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%94%e5%9b%9e/" title="返回">返回</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e9%99%85%e5%ba%94%e7%94%a8/" title="实际应用">实际应用</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>PHP实现发红包程序的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41nb6GM.html" rel="bookmark">使用PHP编写发红包程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用PHP编写发红包程序 http://www.jb51.net/article/69815.htm 投稿:hebedich 字体:[增加 减小] 类型:转载 时间:2015-07-22 微信发红包是最近非常火的一件事情,大家或多或少的都发过或者收到过红包,那么下面来看一个我们在生活中常碰到的一个php实现微信红包的程序算法,希望这个程序对各位做微信开的朋友会带来帮助． 使用PHP发红包,当我们输入红包数量和总金额后,PHP会根据这两个值进行随机分配每个金额,保证每个人都能领取到一个红包,每个红			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dv6e94.html" rel="bookmark">用Python编写简单的发红包程序和计算器原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用Python编写简单的发红包程序: 第一种解法:数轴方法解决 import random def red_packet(money,num): money = money * 100 #将钱数转换成分为单位 ret = random.sample(range(1,money),num-1) #在最低钱数1分与总钱数之间生成人数减1个数作为数轴的节点 ret.sort() #对列表进行排序 ret.insert(0,0) ret.append(money) for i in range(len(			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e1OjZ0.html" rel="bookmark">python&plus;redis简单实现发红包程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				redis是什么? Redis 是一个高性能的key-value数据库! 想进一步了解请移步搜索引擎自行查找. 编写这个小程序的目的就是对redis进行一个简单的小操作,对redis有一个初步的了解,并未有什么高大尚的骚操作,适合小白阅读. 程序共分为三个部分. 1.创建红包 2.将红包存储到数据库 3.取出红包 1.创建红包 首先需要确定创建红包需要哪些参数. 1.红包的最小金额0.01 2.红包的数量 3.红包总金额 4.红包需要一个ID号(存储数据库的时候需要使用) 5.每个红包的金额 1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y8B1JM.html" rel="bookmark">PHP&plus;Ajax手机移动端发红包实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基本流程:当输入完红包数量和总金额后,PHP会根据这两个值进行随机分配每个金额,保证每个人都能领取到一个红包,且每个红包金额不等,并且所有红包金额总额等于总金额. 实现原理:设定总金额为10元,有N个人随机领取:N=1 第一个则红包金额=X元:N=2 第二个为保证第二个红包可以正常发出,第一个红包金额=0.01至9.99之间的某个随机数第二个红包=10-第一个红包金额:N=3 第三个红包1=0.01至9.99之间的某个随机数红包2=0.01至(10-红包1-0.01)的某个随机数红包3=10-红			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pvEB80.html" rel="bookmark">qq划屏幕红包程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				qq划屏幕红包程序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47qOg60.html" rel="bookmark">发红包营销，东鹏特饮是这样玩的</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如今一物一码的天下,也是消费者的天下,如何绑定客户的粘性,就得要抓住消费者心理,综上所述,红包是最好的兴奋剂.企业营销就从这开始了.如上有一些大品牌就早先做起了这个活动,效果那是非常好,中小企业也应该跟上趋势,才能提高市场竞争力,达到营销的好效果.微信扫一扫摇红包系统.商品二维码扫一扫摇红包软件开发.酒品扫一扫领红包系统开发.酒品扫码关注领红包软件开发.酒品扫码分享领红包软件开发.酒品扫码数钱红包系统.饮料扫码关注领红包系统.快消品扫一扫摇红包系统开发咨询潘经理188-2518-9707(tel			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jLWLg4.html" rel="bookmark">js 发红包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;!DOCTYPE HTML&gt; &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=utf-8&quot;&gt; &lt;title&gt;无标题文档&lt;/title&gt; &lt;script&gt; window.onload = function (){ var oBtn = $('btn'); var num = $('nu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzkRzW0.html" rel="bookmark">php发红包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				?/** * 发红包函数实现 * @param float $total    红包金额 * @param int $num        红包个数 * @return  返回数组 */function luckymoney($total,$num){    $min=0.01;//每个人最少能收到0.01元    $arr[]=array() ;    for ($i=0;$i&lt;$num-1;$i++)    {        $safe_total=($total-($num-$i)*$mi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyD2dm4.html" rel="bookmark">支付宝商家红包发红包步骤</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				https://hb.alipay.com/登陆商家支付宝账号 便看到 发红包 和 红包管理 输入必要的信息 商家们赶紧发起来吧.互联网公司也可以.只要有企业支付宝账号即可.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/w3vQ7X0.html" rel="bookmark" class="title">java  byte to hex</a>
					<div>
						java  byte to hex 16 package com.longtop.client.codec.encryp; public class HexTransfer { /** * 将byte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j35gPXM.html" rel="bookmark" class="title">python学习之成员信息增删改查</a>
					<div>
						主要实现了成员信息的增加,修改,查询,和删除功能,写着玩玩,在写的过程中,遇到的问题,旧新成员信息数据的合并,手机号和邮箱的验证, #!/usr/bin/env python# coding=utf8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JDd2l0.html" rel="bookmark" class="title">安装Cocoapods， 更新gem出现的问题</a>
					<div>
						我现在需要安装Cocoapods .gem的镜像一景更换为淘宝的了.执行sudo gem install cocoapods出现错误: ERROR: While executing gem ... ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkDxbM.html" rel="bookmark" class="title">步步为营-50-事务</a>
					<div>
						说明:比较常用 1 事务的四大特性: 1.1 原子性atomicity 一个事务中包含的多个SQL语句,要么同时成功,要么同时失败. 1.2 一致性consistency 事务必须使数据库从从一个一致 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDo6p3.html" rel="bookmark" class="title">公开封尘已久的即时通讯源码&lpar;转&rpar;</a>
					<div>
						看到最近有人研究IM,把以前的东西翻出来了,供想学习这方面的研究研究 通讯协议UDP,聊天方式点对点(P2P) 此项目简单实现了早期QQ的基本功能 文字聊天 表情,图片发送 发送离线消息,图片 在线/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0K2b6rM.html" rel="bookmark" class="title">Cocos2d-x对图片进行各种操作</a>
					<div>
						关于精灵的各种操作,总结一下以便以后复习查找. 内容简要: 1.初始化 2.创建无图的精灵 3.设置精灵贴图大小  4.添加入层中 5.对精灵进行缩放  6.对精灵款或高进行缩放  7.旋转精灵 8. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDaXp3.html" rel="bookmark" class="title">nagios监控安装esxi的服务器（宿主机）</a>
					<div>
						首先,该博文大部分内容来自网络,少部分是自己监控过程中遇到的问题.如果有侵权,请联系告知!!! 现在互联网公司,有能力的都是自己研发监控系统,要么就是zabbix或者小米的监控,还都二次开发等等,可能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRlVb0.html" rel="bookmark" class="title">1059&period; C语言竞赛&lpar;20&rpar;</a>
					<div>
						1059. C语言竞赛(20) C语言竞赛是浙江大学计算机学院主持的一个欢乐的竞赛.既然竞赛主旨是为了好玩,颁奖规则也就制定得很滑稽: 0. 冠军将赢得一份&quot;神秘大奖&quot;(比如很巨大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRKgb0.html" rel="bookmark" class="title">CodeForces - 750D New Year and Fireworks</a>
					<div>
						因为 烟花的最大范围是各个方向150格 所以 最大的空间应该是 300*300 BFS和DFS均可 模拟每一个烟花爆炸的过程 但是要注意 需要一个数组来排重 在某一个爆炸点 如果爆炸的方向 和爆炸的层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzQv80.html" rel="bookmark" class="title">图文混排测试</a>
					<div>
						Figure 8: 拱桥					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aOWPQ4.html" rel="bookmark" class="title">Docker 集群环境实现的新方式</a>
					<div>
						近几年来,Docker 作为一个开源的应用容器引擎,深受广大开发者的欢迎.随着 Docker 生态圈的不断建设,应用领域越来越广.云计算,大数据,移动技术的快速发展,加之企业业务需求的不断变化,紧随技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDVrOM.html" rel="bookmark" class="title">xml Schema import</a>
					<div>
						first_.xsd &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;xs:schema xmlns:xs=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLZKnA3.html" rel="bookmark" class="title">c语言知识框架</a>
					<div>
						想要这张图的发送&quot;C语言知识框架&quot;到[email protected].					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rbOxX3.html" rel="bookmark" class="title">火星人起程回国，带回什么礼物？</a>
					<div>
						在圣诞节期间,美国商品市场大甩卖,便宜货多多.火星人带回什么好东西? 12月25日,在圣诞节那天,火星人拜访J.Keisker教授,详细讨论了质点的直线运动问题.也就是说,点x在直线上运动,无限地接近 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJw2m3.html" rel="bookmark" class="title">Eclipse Java注释模板设置详解以及版权声明</a>
					<div>
						网上的Eclipse注释模板,在这里稍稍整理一些比较常用的. 编辑注释模板的方法:Window-&gt;Preference-&gt;Java-&gt;Code Style-&gt;Code Temp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jLPqA4.html" rel="bookmark" class="title">矩阵快速幂 HDOJ 5318 The Goddess Of The Moon</a>
					<div>
						题目传送门 1 /* 2 DP::dp[i][k] 表示选择i个字符串,最后一次是k类型的字符串,它由sum (dp[i-1][j]) (a[j], a[k] is ok)累加而来 3 矩阵快速幂:将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBOOj0.html" rel="bookmark" class="title">linux下的mysql自动备份shell</a>
					<div>
						#!/bin/bash # mysql 的备份脚本 # 备份原理: # 1 # 使用列举出所有的库; # 2 # 使用每个库,列举出每张表,除了指定忽略的库; # 3 # 使用mysqldump 导出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLr26k3.html" rel="bookmark" class="title">多线程操作界面显示</a>
					<div>
						public DlgCommInfo() { System.Windows.Forms.Control.CheckForIllegalCrossThreadCalls = false; Initial ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1kYo3.html" rel="bookmark" class="title">ArcGIS 10&period;1 for Desktop新特性之地理标记照片</a>
					<div>
						转自:http://blog.csdn.net/esrichinacd/article/details/7730825 地理标记照片是指带有地理位置信息的照片,通常通过内置GPS的数码相机或智能手机拍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38y1YA4.html" rel="bookmark" class="title">yum软件管理器，及yum源配置</a>
					<div>
						说到yum源就必须说到linux系统中特有的依赖关系问题,yum就是为了解决依赖关系而存在的.yum源就相当是一个目录项,当我们使用yum机制安装软件时,若需要安装依赖软件,则yum机制就会根据在yu ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
